Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/builder.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -752,7 +758,40 @@
         if ((*ListRunner)->ActiveFlag) {
         mol = *ListRunner;
-        Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
+        DoLog(0) && (Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl);
         RemoveAtoms(mol);
       }
+      break;
+
+    case 't': // turn/rotate atom
+      for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++)
+        if ((*ListRunner)->ActiveFlag) {
+          mol = *ListRunner;
+          DoLog(0) && (Log() << Verbose(0) << "Turning atom around another bond - first is atom to turn, second (central) and third specify bond" << endl);
+          first = mol->AskAtom("Enter turning atom: ");
+          second = mol->AskAtom("Enter central atom: ");
+          third  = mol->AskAtom("Enter bond atom: ");
+          cout << Verbose(0) << "Enter new angle in degrees: ";
+          double tmp = 0.;
+          cin >> tmp;
+          // calculate old angle
+          x.CopyVector((const Vector *)&first->x);
+          x.SubtractVector((const Vector *)&second->x);
+          y.CopyVector((const Vector *)&third->x);
+          y.SubtractVector((const Vector *)&second->x);
+          double alpha = (acos(x.ScalarProduct((const Vector *)&y)/(y.Norm()*x.Norm()))/M_PI*180.);
+          cout << Verbose(0) << "Bond angle between first atom Nr." << first->nr << ", central atom Nr." << second->nr << " and last atom Nr." << third->nr << ": ";
+          cout << Verbose(0) << alpha << " degrees" << endl;
+          // rotate
+          z.MakeNormalVector(&x,&y);
+          x.RotateVector(&z,(alpha-tmp)*M_PI/180.);
+          x.AddVector(&second->x);
+          first->x.CopyVector(&x);
+          // check new angle
+          x.CopyVector((const Vector *)&first->x);
+          x.SubtractVector((const Vector *)&second->x);
+          alpha = (acos(x.ScalarProduct((const Vector *)&y)/(y.Norm()*x.Norm()))/M_PI*180.);
+          cout << Verbose(0) << "new Bond angle between first atom Nr." << first->nr << ", central atom Nr." << second->nr << " and last atom Nr." << third->nr << ": ";
+          cout << Verbose(0) << alpha << " degrees" << endl;
+        }
       break;
 
@@ -762,14 +801,14 @@
         int Z;
         mol = *ListRunner;
-        Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
+        DoLog(0) && (Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl);
         first = NULL;
         do {
-          Log() << Verbose(0) << "Change the element of which atom: ";
+          DoLog(0) && (Log() << Verbose(0) << "Change the element of which atom: ");
           cin >> Z;
         } while ((first = mol->FindAtom(Z)) == NULL);
-        Log() << Verbose(0) << "New element by atomic number Z: ";
+        DoLog(0) && (Log() << Verbose(0) << "New element by atomic number Z: ");
         cin >> Z;
         first->type = periode->FindElement(Z);
-        Log() << Verbose(0) << "Atom " << first->nr << "'s element is " << first->type->name << "." << endl;
+        DoLog(0) && (Log() << Verbose(0) << "Atom " << first->nr << "'s element is " << first->type->name << "." << endl);
       }
       break;
@@ -792,23 +831,23 @@
   MoleculeLeafClass *Subgraphs = NULL;
 
-  Log() << Verbose(0) << "=========MANIPULATE GLOBALLY===================" << endl;
-  Log() << Verbose(0) << "c - scale by unit transformation" << endl;
-  Log() << Verbose(0) << "d - duplicate molecule/periodic cell" << endl;
-  Log() << Verbose(0) << "f - fragment molecule many-body bond order style" << endl;
-  Log() << Verbose(0) << "g - center atoms in box" << endl;
-  Log() << Verbose(0) << "i - realign molecule" << endl;
-  Log() << Verbose(0) << "m - mirror all molecules" << endl;
-  Log() << Verbose(0) << "o - create connection matrix" << endl;
-  Log() << Verbose(0) << "t - translate molecule by vector" << endl;
-  Log() << Verbose(0) << "all else - go back" << endl;
-  Log() << Verbose(0) << "===============================================" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "=========MANIPULATE GLOBALLY===================" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "c - scale by unit transformation" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "d - duplicate molecule/periodic cell" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "f - fragment molecule many-body bond order style" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "g - center atoms in box" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "i - realign molecule" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "m - mirror all molecules" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "o - create connection matrix" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "t - translate molecule by vector" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "all else - go back" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "===============================================" << endl);
   if (molecules->NumberOfActiveMolecules() > 1)
-    eLog() << Verbose(2) << "There is more than one molecule active! Atoms will be added to each." << endl;
-  Log() << Verbose(0) << "INPUT: ";
+    DoeLog(2) && (eLog()<< Verbose(2) << "There is more than one molecule active! Atoms will be added to each." << endl);
+  DoLog(0) && (Log() << Verbose(0) << "INPUT: ");
   cin >> choice;
 
   switch (choice) {
     default:
-      Log() << Verbose(0) << "Not a valid choice." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "Not a valid choice." << endl);
       break;
 
@@ -817,8 +856,8 @@
         if ((*ListRunner)->ActiveFlag) {
         mol = *ListRunner;
-        Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
-        Log() << Verbose(0) << "State the axis [(+-)123]: ";
+        DoLog(0) && (Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl);
+        DoLog(0) && (Log() << Verbose(0) << "State the axis [(+-)123]: ");
         cin >> axis;
-        Log() << Verbose(0) << "State the factor: ";
+        DoLog(0) && (Log() << Verbose(0) << "State the factor: ");
         cin >> faktor;
 
@@ -837,8 +876,8 @@
           }
           if (count != j)
-            eLog() << Verbose(1) << "AtomCount " << count << " is not equal to number of atoms in molecule " << j << "!" << endl;
+            DoeLog(1) && (eLog()<< Verbose(1) << "AtomCount " << count << " is not equal to number of atoms in molecule " << j << "!" << endl);
           x.Zero();
           y.Zero();
-          y.x[abs(axis)-1] = mol->cell_size[(abs(axis) == 2) ? 2 : ((abs(axis) == 3) ? 5 : 0)] * abs(axis)/axis; // last term is for sign, first is for magnitude
+          y.x[abs(axis)-1] = World::getInstance().getDomain()[(abs(axis) == 2) ? 2 : ((abs(axis) == 3) ? 5 : 0)] * abs(axis)/axis; // last term is for sign, first is for magnitude
           for (int i=1;i<faktor;i++) {  // then add this list with respective translation factor times
             x.AddVector(&y); // per factor one cell width further
@@ -863,5 +902,5 @@
             mol->Translate(&x);
           }
-          mol->cell_size[(abs(axis) == 2) ? 2 : ((abs(axis) == 3) ? 5 : 0)] *= faktor;
+          World::getInstance().getDomain()[(abs(axis) == 2) ? 2 : ((abs(axis) == 3) ? 5 : 0)] *= faktor;
         }
       }
@@ -876,5 +915,5 @@
         if ((*ListRunner)->ActiveFlag) {
         mol = *ListRunner;
-        Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
+        DoLog(0) && (Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl);
         CenterAtoms(mol);
       }
@@ -885,5 +924,5 @@
         if ((*ListRunner)->ActiveFlag) {
         mol = *ListRunner;
-        Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
+        DoLog(0) && (Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl);
         AlignAtoms(periode, mol);
       }
@@ -894,5 +933,5 @@
         if ((*ListRunner)->ActiveFlag) {
         mol = *ListRunner;
-        Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
+        DoLog(0) && (Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl);
         MirrorAtoms(mol);
       }
@@ -905,10 +944,10 @@
           double bonddistance;
           clock_t start,end;
-          Log() << Verbose(0) << "What's the maximum bond distance: ";
+          DoLog(0) && (Log() << Verbose(0) << "What's the maximum bond distance: ");
           cin >> bonddistance;
           start = clock();
           mol->CreateAdjacencyList(bonddistance, configuration->GetIsAngstroem(), &BondGraph::CovalentMinMaxDistance, NULL);
           end = clock();
-          Log() << Verbose(0) << "Clocks for this operation: " << (end-start) << ", time: " << ((double)(end-start)/CLOCKS_PER_SEC) << "s." << endl;
+          DoLog(0) && (Log() << Verbose(0) << "Clocks for this operation: " << (end-start) << ", time: " << ((double)(end-start)/CLOCKS_PER_SEC) << "s." << endl);
         }
       break;
@@ -918,7 +957,7 @@
         if ((*ListRunner)->ActiveFlag) {
         mol = *ListRunner;
-        Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
-        Log() << Verbose(0) << "Enter translation vector." << endl;
-        x.AskPosition(mol->cell_size,0);
+        DoLog(0) && (Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl);
+        DoLog(0) && (Log() << Verbose(0) << "Enter translation vector." << endl);
+        x.AskPosition(World::getInstance().getDomain(),0);
         mol->Center.AddVector((const Vector *)&x);
      }
@@ -947,22 +986,22 @@
   molecule *mol = NULL;
 
-  Log() << Verbose(0) << "==========EDIT MOLECULES=====================" << endl;
-  Log() << Verbose(0) << "c - create new molecule" << endl;
-  Log() << Verbose(0) << "l - load molecule from xyz file" << endl;
-  Log() << Verbose(0) << "n - change molecule's name" << endl;
-  Log() << Verbose(0) << "N - give molecules filename" << endl;
-  Log() << Verbose(0) << "p - parse atoms in xyz file into molecule" << endl;
-  Log() << Verbose(0) << "r - remove a molecule" << endl;
-  Log() << Verbose(0) << "all else - go back" << endl;
-  Log() << Verbose(0) << "===============================================" << endl;
-  Log() << Verbose(0) << "INPUT: ";
+  DoLog(0) && (Log() << Verbose(0) << "==========EDIT MOLECULES=====================" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "c - create new molecule" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "l - load molecule from xyz file" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "n - change molecule's name" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "N - give molecules filename" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "p - parse atoms in xyz file into molecule" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "r - remove a molecule" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "all else - go back" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "===============================================" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "INPUT: ");
   cin >> choice;
 
   switch (choice) {
     default:
-      Log() << Verbose(0) << "Not a valid choice." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "Not a valid choice." << endl);
       break;
     case 'c':
-      mol = new molecule(periode);
+      mol = World::getInstance().createMolecule();
       molecules->insert(mol);
       break;
@@ -971,8 +1010,8 @@
       {
         char filename[MAXSTRINGSIZE];
-        Log() << Verbose(0) << "Format should be XYZ with: ShorthandOfElement\tX\tY\tZ" << endl;
-        mol = new molecule(periode);
+        DoLog(0) && (Log() << Verbose(0) << "Format should be XYZ with: ShorthandOfElement\tX\tY\tZ" << endl);
+        mol = World::getInstance().createMolecule();
         do {
-          Log() << Verbose(0) << "Enter file name: ";
+          DoLog(0) && (Log() << Verbose(0) << "Enter file name: ");
           cin >> filename;
         } while (!mol->AddXYZFile(filename));
@@ -980,10 +1019,11 @@
         // center at set box dimensions
         mol->CenterEdge(&center);
-        mol->cell_size[0] = center.x[0];
-        mol->cell_size[1] = 0;
-        mol->cell_size[2] = center.x[1];
-        mol->cell_size[3] = 0;
-        mol->cell_size[4] = 0;
-        mol->cell_size[5] = center.x[2];
+        double * const cell_size = World::getInstance().getDomain();
+        cell_size[0] = center.x[0];
+        cell_size[1] = 0;
+        cell_size[2] = center.x[1];
+        cell_size[3] = 0;
+        cell_size[4] = 0;
+        cell_size[5] = center.x[2];
         molecules->insert(mol);
       }
@@ -994,9 +1034,9 @@
         char filename[MAXSTRINGSIZE];
         do {
-          Log() << Verbose(0) << "Enter index of molecule: ";
+          DoLog(0) && (Log() << Verbose(0) << "Enter index of molecule: ");
           cin >> nr;
           mol = molecules->ReturnIndex(nr);
         } while (mol == NULL);
-        Log() << Verbose(0) << "Enter name: ";
+        DoLog(0) && (Log() << Verbose(0) << "Enter name: ");
         cin >> filename;
         strcpy(mol->name, filename);
@@ -1008,9 +1048,9 @@
         char filename[MAXSTRINGSIZE];
         do {
-          Log() << Verbose(0) << "Enter index of molecule: ";
+          DoLog(0) && (Log() << Verbose(0) << "Enter index of molecule: ");
           cin >> nr;
           mol = molecules->ReturnIndex(nr);
         } while (mol == NULL);
-        Log() << Verbose(0) << "Enter name: ";
+        DoLog(0) && (Log() << Verbose(0) << "Enter name: ");
         cin >> filename;
         mol->SetNameFromFilename(filename);
@@ -1023,11 +1063,11 @@
         mol = NULL;
         do {
-          Log() << Verbose(0) << "Enter index of molecule: ";
+          DoLog(0) && (Log() << Verbose(0) << "Enter index of molecule: ");
           cin >> nr;
           mol = molecules->ReturnIndex(nr);
         } while (mol == NULL);
-        Log() << Verbose(0) << "Format should be XYZ with: ShorthandOfElement\tX\tY\tZ" << endl;
+        DoLog(0) && (Log() << Verbose(0) << "Format should be XYZ with: ShorthandOfElement\tX\tY\tZ" << endl);
         do {
-          Log() << Verbose(0) << "Enter file name: ";
+          DoLog(0) && (Log() << Verbose(0) << "Enter file name: ");
           cin >> filename;
         } while (!mol->AddXYZFile(filename));
@@ -1037,5 +1077,5 @@
 
     case 'r':
-      Log() << Verbose(0) << "Enter index of molecule: ";
+      DoLog(0) && (Log() << Verbose(0) << "Enter index of molecule: ");
       cin >> nr;
       count = 1;
@@ -1060,18 +1100,22 @@
   char choice;  // menu choice char
 
-  Log() << Verbose(0) << "===========MERGE MOLECULES=====================" << endl;
-  Log() << Verbose(0) << "a - simple add of one molecule to another" << endl;
-  Log() << Verbose(0) << "e - embedding merge of two molecules" << endl;
-  Log() << Verbose(0) << "m - multi-merge of all molecules" << endl;
-  Log() << Verbose(0) << "s - scatter merge of two molecules" << endl;
-  Log() << Verbose(0) << "t - simple merge of two molecules" << endl;
-  Log() << Verbose(0) << "all else - go back" << endl;
-  Log() << Verbose(0) << "===============================================" << endl;
-  Log() << Verbose(0) << "INPUT: ";
+  DoLog(0) && (Log() << Verbose(0) << "===========MERGE MOLECULES=====================" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "a - simple add of one molecule to another" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "b - count the number of bonds of two elements" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "B - count the number of bonds of three elements " << endl);
+  DoLog(0) && (Log() << Verbose(0) << "e - embedding merge of two molecules" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "h - count the number of hydrogen bonds" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "b - count the number of hydrogen bonds" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "m - multi-merge of all molecules" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "s - scatter merge of two molecules" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "t - simple merge of two molecules" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "all else - go back" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "===============================================" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "INPUT: ");
   cin >> choice;
 
   switch (choice) {
     default:
-      Log() << Verbose(0) << "Not a valid choice." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "Not a valid choice." << endl);
       break;
 
@@ -1082,10 +1126,10 @@
         {
           do {
-            Log() << Verbose(0) << "Enter index of destination molecule: ";
+            DoLog(0) && (Log() << Verbose(0) << "Enter index of destination molecule: ");
             cin >> dest;
             destmol = molecules->ReturnIndex(dest);
           } while ((destmol == NULL) && (dest != -1));
           do {
-            Log() << Verbose(0) << "Enter index of source molecule to add from: ";
+            DoLog(0) && (Log() << Verbose(0) << "Enter index of source molecule to add from: ");
             cin >> src;
             srcmol = molecules->ReturnIndex(src);
@@ -1097,4 +1141,56 @@
       break;
 
+    case 'b':
+      {
+        const int nr = 2;
+        char *names[nr] = {"first", "second"};
+        int Z[nr];
+        element *elements[nr];
+        for (int i=0;i<nr;i++) {
+          Z[i] = 0;
+          do {
+            cout << "Enter " << names[i] << " element: ";
+            cin >> Z[i];
+          } while ((Z[i] <= 0) && (Z[i] > MAX_ELEMENTS));
+          elements[i] = periode->FindElement(Z[i]);
+        }
+        const int count = CountBondsOfTwo(molecules, elements[0], elements[1]);
+        cout << endl << "There are " << count << " ";
+        for (int i=0;i<nr;i++) {
+          if (i==0)
+            cout << elements[i]->symbol;
+          else
+            cout << "-" << elements[i]->symbol;
+        }
+        cout << " bonds." << endl;
+      }
+    break;
+
+    case 'B':
+      {
+        const int nr = 3;
+        char *names[nr] = {"first", "second", "third"};
+        int Z[nr];
+        element *elements[nr];
+        for (int i=0;i<nr;i++) {
+          Z[i] = 0;
+          do {
+            cout << "Enter " << names[i] << " element: ";
+            cin >> Z[i];
+          } while ((Z[i] <= 0) && (Z[i] > MAX_ELEMENTS));
+          elements[i] = periode->FindElement(Z[i]);
+        }
+        const int count = CountBondsOfThree(molecules, elements[0], elements[1], elements[2]);
+        cout << endl << "There are " << count << " ";
+        for (int i=0;i<nr;i++) {
+          if (i==0)
+            cout << elements[i]->symbol;
+          else
+            cout << "-" << elements[i]->symbol;
+        }
+        cout << " bonds." << endl;
+      }
+    break;
+
     case 'e':
       {
@@ -1102,10 +1198,10 @@
         molecule *srcmol = NULL, *destmol = NULL;
         do {
-          Log() << Verbose(0) << "Enter index of matrix molecule (the variable one): ";
+          DoLog(0) && (Log() << Verbose(0) << "Enter index of matrix molecule (the variable one): ");
           cin >> src;
           srcmol = molecules->ReturnIndex(src);
         } while ((srcmol == NULL) && (src != -1));
         do {
-          Log() << Verbose(0) << "Enter index of molecule to merge into (the fixed one): ";
+          DoLog(0) && (Log() << Verbose(0) << "Enter index of molecule to merge into (the fixed one): ");
           cin >> dest;
           destmol = molecules->ReturnIndex(dest);
@@ -1116,4 +1212,14 @@
       break;
 
+    case 'h':
+      {
+        int Z;
+        cout << "Please enter interface element: ";
+        cin >> Z;
+        element * const InterfaceElement = periode->FindElement(Z);
+        cout << endl << "There are " << CountHydrogenBridgeBonds(molecules, InterfaceElement) << " hydrogen bridges with connections to " << (InterfaceElement != 0 ? InterfaceElement->name : "None") << "." << endl;
+      }
+      break;
+
     case 'm':
       {
@@ -1121,5 +1227,5 @@
         molecule *mol = NULL;
         do {
-          Log() << Verbose(0) << "Enter index of molecule to merge into: ";
+          DoLog(0) && (Log() << Verbose(0) << "Enter index of molecule to merge into: ");
           cin >> nr;
           mol = molecules->ReturnIndex(nr);
@@ -1138,5 +1244,5 @@
 
     case 's':
-      Log() << Verbose(0) << "Not implemented yet." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "Not implemented yet." << endl);
       break;
 
@@ -1147,10 +1253,10 @@
         {
           do {
-            Log() << Verbose(0) << "Enter index of destination molecule: ";
+            DoLog(0) && (Log() << Verbose(0) << "Enter index of destination molecule: ");
             cin >> dest;
             destmol = molecules->ReturnIndex(dest);
           } while ((destmol == NULL) && (dest != -1));
           do {
-            Log() << Verbose(0) << "Enter index of source molecule to merge into: ";
+            DoLog(0) && (Log() << Verbose(0) << "Enter index of source molecule to merge into: ");
             cin >> src;
             srcmol = molecules->ReturnIndex(src);
@@ -1180,5 +1286,5 @@
     mol = (molecules->ListOfMolecules.front())->CopyMolecule();
   else {
-    eLog() << Verbose(0) << "I don't have anything to test on ... ";
+    DoeLog(0) && (eLog()<< Verbose(0) << "I don't have anything to test on ... ");
     performCriticalExit();
     return;
@@ -1187,5 +1293,5 @@
 
   // generate some KeySets
-  Log() << Verbose(0) << "Generating KeySets." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Generating KeySets." << endl);
   KeySet TestSets[mol->AtomCount+1];
   i=1;
@@ -1197,11 +1303,11 @@
     i++;
   }
-  Log() << Verbose(0) << "Testing insertion of already present item in KeySets." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Testing insertion of already present item in KeySets." << endl);
   KeySetTestPair test;
   test = TestSets[mol->AtomCount-1].insert(Walker->nr);
   if (test.second) {
-    Log() << Verbose(1) << "Insertion worked?!" << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Insertion worked?!" << endl);
   } else {
-    Log() << Verbose(1) << "Insertion rejected: Present object is " << (*test.first) << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Insertion rejected: Present object is " << (*test.first) << "." << endl);
   }
   TestSets[mol->AtomCount].insert(mol->end->previous->nr);
@@ -1209,37 +1315,37 @@
 
   // constructing Graph structure
-  Log() << Verbose(0) << "Generating Subgraph class." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Generating Subgraph class." << endl);
   Graph Subgraphs;
 
   // insert KeySets into Subgraphs
-  Log() << Verbose(0) << "Inserting KeySets into Subgraph class." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Inserting KeySets into Subgraph class." << endl);
   for (int j=0;j<mol->AtomCount;j++) {
     Subgraphs.insert(GraphPair (TestSets[j],pair<int, double>(counter++, 1.)));
   }
-  Log() << Verbose(0) << "Testing insertion of already present item in Subgraph." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Testing insertion of already present item in Subgraph." << endl);
   GraphTestPair test2;
   test2 = Subgraphs.insert(GraphPair (TestSets[mol->AtomCount],pair<int, double>(counter++, 1.)));
   if (test2.second) {
-    Log() << Verbose(1) << "Insertion worked?!" << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Insertion worked?!" << endl);
   } else {
-    Log() << Verbose(1) << "Insertion rejected: Present object is " << (*(test2.first)).second.first << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Insertion rejected: Present object is " << (*(test2.first)).second.first << "." << endl);
   }
 
   // show graphs
-  Log() << Verbose(0) << "Showing Subgraph's contents, checking that it's sorted." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Showing Subgraph's contents, checking that it's sorted." << endl);
   Graph::iterator A = Subgraphs.begin();
   while (A !=  Subgraphs.end()) {
-    Log() << Verbose(0) << (*A).second.first << ": ";
+    DoLog(0) && (Log() << Verbose(0) << (*A).second.first << ": ");
     KeySet::iterator key = (*A).first.begin();
     comp = -1;
     while (key != (*A).first.end()) {
       if ((*key) > comp)
-        Log() << Verbose(0) << (*key) << " ";
+        DoLog(0) && (Log() << Verbose(0) << (*key) << " ");
       else
-        Log() << Verbose(0) << (*key) << "! ";
+        DoLog(0) && (Log() << Verbose(0) << (*key) << "! ");
       comp = (*key);
       key++;
     }
-    Log() << Verbose(0) << endl;
+    DoLog(0) && (Log() << Verbose(0) << endl);
     A++;
   }
@@ -1248,4 +1354,128 @@
 
 #endif
+
+/** Tries given filename or standard on saving the config file.
+ * \param *ConfigFileName name of file
+ * \param *configuration pointer to configuration structure with all the values
+ * \param *periode pointer to periodentafel structure with all the elements
+ * \param *molecules list of molecules structure with all the atoms and coordinates
+ */
+static void SaveConfig(char *ConfigFileName, config *configuration, periodentafel *periode, MoleculeListClass *molecules)
+{
+  char filename[MAXSTRINGSIZE];
+  ofstream output;
+  molecule *mol = World::getInstance().createMolecule();
+  mol->SetNameFromFilename(ConfigFileName);
+
+  if (!strcmp(configuration->configpath, configuration->GetDefaultPath())) {
+    DoeLog(2) && (eLog()<< Verbose(2) << "config is found under different path then stated in config file::defaultpath!" << endl);
+  }
+
+
+  // first save as PDB data
+  if (ConfigFileName != NULL)
+    strcpy(filename, ConfigFileName);
+  if (output == NULL)
+    strcpy(filename,"main_pcp_linux");
+  DoLog(0) && (Log() << Verbose(0) << "Saving as pdb input ");
+  if (configuration->SavePDB(filename, molecules))
+    DoLog(0) && (Log() << Verbose(0) << "done." << endl);
+  else
+    DoLog(0) && (Log() << Verbose(0) << "failed." << endl);
+
+  // then save as tremolo data file
+  if (ConfigFileName != NULL)
+    strcpy(filename, ConfigFileName);
+  if (output == NULL)
+    strcpy(filename,"main_pcp_linux");
+  DoLog(0) && (Log() << Verbose(0) << "Saving as tremolo data input ");
+  if (configuration->SaveTREMOLO(filename, molecules))
+    DoLog(0) && (Log() << Verbose(0) << "done." << endl);
+  else
+    DoLog(0) && (Log() << Verbose(0) << "failed." << endl);
+
+  // translate each to its center and merge all molecules in MoleculeListClass into this molecule
+  int N = molecules->ListOfMolecules.size();
+  int *src = new int[N];
+  N=0;
+  for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++) {
+    src[N++] = (*ListRunner)->IndexNr;
+    (*ListRunner)->Translate(&(*ListRunner)->Center);
+  }
+  molecules->SimpleMultiAdd(mol, src, N);
+  delete[](src);
+
+  // ... and translate back
+  for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++) {
+    (*ListRunner)->Center.Scale(-1.);
+    (*ListRunner)->Translate(&(*ListRunner)->Center);
+    (*ListRunner)->Center.Scale(-1.);
+  }
+
+  DoLog(0) && (Log() << Verbose(0) << "Storing configuration ... " << endl);
+  // get correct valence orbitals
+  mol->CalculateOrbitals(*configuration);
+  configuration->InitMaxMinStopStep = configuration->MaxMinStopStep = configuration->MaxPsiDouble;
+  if (ConfigFileName != NULL) { // test the file name
+    strcpy(filename, ConfigFileName);
+    output.open(filename, ios::trunc);
+  } else if (strlen(configuration->configname) != 0) {
+    strcpy(filename, configuration->configname);
+    output.open(configuration->configname, ios::trunc);
+    } else {
+      strcpy(filename, DEFAULTCONFIG);
+      output.open(DEFAULTCONFIG, ios::trunc);
+    }
+  output.close();
+  output.clear();
+  DoLog(0) && (Log() << Verbose(0) << "Saving of config file ");
+  if (configuration->Save(filename, periode, mol))
+    DoLog(0) && (Log() << Verbose(0) << "successful." << endl);
+  else
+    DoLog(0) && (Log() << Verbose(0) << "failed." << endl);
+
+  // and save to xyz file
+  if (ConfigFileName != NULL) {
+    strcpy(filename, ConfigFileName);
+    strcat(filename, ".xyz");
+    output.open(filename, ios::trunc);
+  }
+  if (output == NULL) {
+    strcpy(filename,"main_pcp_linux");
+    strcat(filename, ".xyz");
+    output.open(filename, ios::trunc);
+  }
+  DoLog(0) && (Log() << Verbose(0) << "Saving of XYZ file ");
+  if (mol->MDSteps <= 1) {
+    if (mol->OutputXYZ(&output))
+      DoLog(0) && (Log() << Verbose(0) << "successful." << endl);
+    else
+      DoLog(0) && (Log() << Verbose(0) << "failed." << endl);
+  } else {
+    if (mol->OutputTrajectoriesXYZ(&output))
+      DoLog(0) && (Log() << Verbose(0) << "successful." << endl);
+    else
+      DoLog(0) && (Log() << Verbose(0) << "failed." << endl);
+  }
+  output.close();
+  output.clear();
+
+  // and save as MPQC configuration
+  if (ConfigFileName != NULL)
+    strcpy(filename, ConfigFileName);
+  if (output == NULL)
+    strcpy(filename,"main_pcp_linux");
+  DoLog(0) && (Log() << Verbose(0) << "Saving as mpqc input ");
+  if (configuration->SaveMPQC(filename, mol))
+    DoLog(0) && (Log() << Verbose(0) << "done." << endl);
+  else
+    DoLog(0) && (Log() << Verbose(0) << "failed." << endl);
+
+  if (!strcmp(configuration->configpath, configuration->GetDefaultPath())) {
+    DoeLog(2) && (eLog()<< Verbose(2) << "config is found under different path then stated in config file::defaultpath!" << endl);
+  }
+
+  World::getInstance().destroyMolecule(mol);
+};
 
 /** Parses the command line options.
@@ -1274,4 +1504,5 @@
   enum ConfigStatus configPresent = absent;
   clock_t start,end;
+  double MaxDistance = -1;
   int argptr;
   molecule *mol = NULL;
@@ -1285,5 +1516,5 @@
     do {
       if (argv[argptr][0] == '-') {
-        Log() << Verbose(0) << "Recognized command line argument: " << argv[argptr][1] << ".\n";
+        DoLog(0) && (Log() << Verbose(0) << "Recognized command line argument: " << argv[argptr][1] << ".\n");
         argptr++;
         switch(argv[argptr-1][1]) {
